diff --git a/test/packaging/install_sh_test.sh b/test/packaging/install_sh_test.sh
new file mode 100644
index 00000000..c6678790
--- /dev/null
+++ b/test/packaging/install_sh_test.sh
@@ -0,0 +1,134 @@
+#!/usr/bin/env bash
+# Lightweight install.sh tests (no bats required). Run from repo root:
+#   bash test/packaging/install_sh_test.sh
+set -uo pipefail
+
+ROOT="$(cd "$(dirname "$0")/../.." && pwd)"
+INSTALL_SH="${ROOT}/packaging/install.sh"
+PASS=0
+FAIL=0
+
+pass() { PASS=$((PASS + 1)); echo "ok - $*"; }
+fail() { FAIL=$((FAIL + 1)); echo "not ok - $*" >&2; }
+
+# Syntax check
+if bash -n "${INSTALL_SH}"; then
+  pass "bash -n install.sh"
+else
+  fail "bash -n install.sh"
+fi
+
+# shellcheck when available
+if command -v shellcheck >/dev/null 2>&1; then
+  if shellcheck -x "${INSTALL_SH}"; then
+    pass "shellcheck install.sh"
+  else
+    fail "shellcheck install.sh"
+  fi
+else
+  echo "skip - shellcheck not installed"
+fi
+
+# Unknown platform refuses
+if ! uname() { echo Plan9; }; export -f uname; bash "${INSTALL_SH}" >/dev/null 2>&1; then
+  fail "unknown OS should fail"
+else
+  pass "unknown OS exits non-zero"
+fi
+unset -f uname 2>/dev/null || true
+
+# Happy path + checksum mismatch against mock HTTP server
+if ! command -v python3 >/dev/null 2>&1; then
+  echo "skip - python3 not available for mock server"
+  echo "install_sh_test: ${PASS} passed, ${FAIL} failed"
+  exit "${FAIL}"
+fi
+
+OS="$(uname -s)"
+ARCH="$(uname -m)"
+case "${OS}-${ARCH}" in
+  Linux-x86_64|Linux-amd64) PLATFORM="linux-x86_64" ;;
+  Darwin-arm64|Darwin-aarch64) PLATFORM="macos-arm64" ;;
+  *)
+    echo "skip - happy path unsupported on ${OS}-${ARCH}"
+    echo "install_sh_test: ${PASS} passed, ${FAIL} failed"
+    exit "${FAIL}"
+    ;;
+esac
+
+ASSET="hive-0.1.0-${PLATFORM}.tar.gz"
+TMP="$(mktemp -d)"
+cleanup() { kill "${SERVER_PID:-}" 2>/dev/null || true; rm -rf "${TMP}"; }
+trap cleanup EXIT
+
+mkdir -p "${TMP}/payload/bin" "${TMP}/payload/templates" "${TMP}/payload/schemas" \
+         "${TMP}/www/download/v0.1.0" "${TMP}/home"
+
+cat > "${TMP}/payload/bin/hive" <<'EOS'
+#!/usr/bin/env bash
+echo "0.1.0"
+EOS
+chmod +x "${TMP}/payload/bin/hive"
+tar -czf "${TMP}/www/download/v0.1.0/${ASSET}" -C "${TMP}/payload" .
+(
+  cd "${TMP}/www/download/v0.1.0"
+  if command -v sha256sum >/dev/null 2>&1; then
+    sha256sum "${ASSET}" > SHA256SUMS
+  else
+    shasum -a 256 "${ASSET}" > SHA256SUMS
+  fi
+)
+
+python3 -m http.server 0 --directory "${TMP}/www" >"${TMP}/http.log" 2>&1 &
+SERVER_PID=$!
+for _ in 1 2 3 4 5 6 7 8 9 10; do
+  PORT="$(grep -oE 'port [0-9]+' "${TMP}/http.log" 2>/dev/null | awk '{print $2}' | head -1 || true)"
+  [[ -n "${PORT:-}" ]] && break
+  sleep 0.1
+done
+
+if [[ -z "${PORT:-}" ]]; then
+  fail "could not start mock http server"
+else
+  if HIVE_VERSION=v0.1.0 \
+     HIVE_GITHUB_RELEASES="http://127.0.0.1:${PORT}" \
+     HIVE_PREFIX="${TMP}/home/.local" \
+     HOME="${TMP}/home" \
+     bash "${INSTALL_SH}" >"${TMP}/install.out" 2>&1; then
+    pass "install.sh happy path"
+    if [[ -x "${TMP}/home/.local/bin/hive" ]]; then
+      pass "binary installed"
+    else
+      fail "binary missing"
+    fi
+    ver="$("${TMP}/home/.local/bin/hive" --version 2>/dev/null || true)"
+    if [[ "${ver}" == "0.1.0" ]]; then
+      pass "version ${ver}"
+    else
+      fail "version want 0.1.0 got ${ver}"
+    fi
+    if [[ -f "${TMP}/home/.local/share/hive/install-channel.yml" ]]; then
+      pass "channel marker written"
+    else
+      fail "channel marker missing"
+    fi
+  else
+    fail "install.sh happy path (see ${TMP}/install.out)"
+    cat "${TMP}/install.out" >&2 || true
+  fi
+
+  # Checksum mismatch
+  echo "deadbeef  ${ASSET}" > "${TMP}/www/download/v0.1.0/SHA256SUMS"
+  if HIVE_VERSION=v0.1.0 \
+     HIVE_GITHUB_RELEASES="http://127.0.0.1:${PORT}" \
+     HIVE_PREFIX="${TMP}/home2/.local" \
+     HOME="${TMP}/home2" \
+     bash "${INSTALL_SH}" >/dev/null 2>&1; then
+    fail "checksum mismatch should abort"
+  else
+    pass "checksum mismatch aborts"
+  fi
+fi
+
+echo "install_sh_test: ${PASS} passed, ${FAIL} failed"
+exit "${FAIL}"
diff --git a/test/packaging/test_install_prompt.rb b/test/packaging/test_install_prompt.rb
new file mode 100644
index 00000000..a43b5625
--- /dev/null
+++ b/test/packaging/test_install_prompt.rb
@@ -0,0 +1,42 @@
+# frozen_string_literal: true
+
+require "test_helper"
+
+class InstallPromptTest < Minitest::Test
+  def prompt
+    @prompt ||= File.read(File.expand_path("../../INSTALL-PROMPT.md", __dir__))
+  end
+
+  def test_names_all_three_channels
+    assert_match(/brew install/i, prompt)
+    assert_match(/hive-bin/, prompt)
+    assert_match(/install\.sh/, prompt)
+  end
+
+  def test_contains_verification_commands
+    assert_includes prompt, "hive --version"
+    assert_includes prompt, "hive doctor"
+  end
+
+  def test_marketplace_conditional
+    assert_match(/marketplace/i, prompt)
+    assert_match(/only if/i, prompt)
+    refute_match(/cp -r.*\.claude/, prompt)
+  end
+
+  def test_no_hardcoded_version_numbers
+    # Must not pin a single release like v0.1.0 as the only install target.
+    # Allow HIVE_VERSION=vX.Y.Z pattern and mention of 0.1.0 in docs is OK
+    # only as example — reject lines that force a specific download URL version.
+    bad = prompt.lines.select { |l| l.match?(%r{releases/download/v\d+\.\d+\.\d+/}) }
+    assert_empty bad, "prompt must use latest / HIVE_VERSION pin, not hardcoded release URLs: #{bad}"
+  end
+
+  def test_stop_on_unsupported
+    assert_match(/STOP/i, prompt)
+  end
+
+  def test_urls_point_at_this_repo
+    assert_match(%r{github\.com/ivankuznetsov/hive}, prompt)
+  end
+end
diff --git a/test/packaging/test_marketplace_guard.rb b/test/packaging/test_marketplace_guard.rb
new file mode 100644
index 00000000..84e5712f
--- /dev/null
+++ b/test/packaging/test_marketplace_guard.rb
@@ -0,0 +1,43 @@
+# frozen_string_literal: true
+
+require "test_helper"
+
+# R7/R12: packaging + init must never write into agent config dirs.
+class MarketplaceGuardTest < Minitest::Test
+  AGENT_DIR_PATTERNS = [
+    %r{~/\.claude},
+    %r{HOME.*\.claude},
+    %r{\.codex/},
+    %r{\.pi/agent}
+  ].freeze
+
+  def test_install_sh_does_not_touch_agent_dirs
+    body = File.read(File.expand_path("../../packaging/install.sh", __dir__))
+    AGENT_DIR_PATTERNS.each do |re|
+      refute_match re, body, "install.sh must not reference #{re}"
+    end
+  end
+
+  def test_init_does_not_write_agent_dirs
+    body = File.read(File.expand_path("../../lib/hive/commands/init.rb", __dir__))
+    refute_match(%r{File\.(write|utils).*claude}, body)
+    refute_match(%r{\.claude/commands}, body)
+    refute_match(%r{\.codex/skills}, body)
+  end
+
+  def test_marketplace_manifest_exists
+    path = File.expand_path("../../marketplace/.claude-plugin/marketplace.json", __dir__)
+    assert File.file?(path)
+    require "json"
+    data = JSON.parse(File.read(path))
+    assert_equal "hive", data["name"]
+    assert data["plugins"].any? { |p| p["name"] == "hive" }
+  end
+
+  def test_aur_and_brew_templates_skip_agent_dirs
+    brew = File.read(File.expand_path("../../packaging/homebrew/hive.rb.erb", __dir__))
+    aur = File.read(File.expand_path("../../packaging/aur/PKGBUILD", __dir__))
+    refute_match(/\.claude/, brew)
+    refute_match(/\.claude/, aur)
+  end
+end
diff --git a/test/packaging/test_version.rb b/test/packaging/test_version.rb
new file mode 100644
index 00000000..27b7cd0e
--- /dev/null
+++ b/test/packaging/test_version.rb
@@ -0,0 +1,42 @@
+# frozen_string_literal: true
+
+require "test_helper"
+require "hive/version"
+require "open3"
+
+class PackagingVersionTest < Minitest::Test
+  def test_version_is_semver
+    assert_match(/\A\d+\.\d+\.\d+\z/, Hive::VERSION)
+  end
+
+  def test_version_matches_lib_hive_constant
+    assert_equal Hive::VERSION, Hive::VERSION
+    # hive.rb requires version.rb — single source of truth
+    assert defined?(Hive::VERSION)
+  end
+
+  def test_version_guard_script_rejects_mismatch
+    root = File.expand_path("../..", __dir__)
+    script = <<~RUBY
+      require "hive/version"
+      tag = "9.9.9"
+      abort "tag \#{tag} != Hive::VERSION \#{Hive::VERSION}" unless tag == Hive::VERSION
+    RUBY
+    out, err, status = Open3.capture3("ruby", "-I#{root}/lib", "-e", script)
+    refute status.success?, "expected mismatch to fail"
+    assert_match(/!= Hive::VERSION/, err + out)
+  end
+
+  def test_version_guard_accepts_matching_tag
+    root = File.expand_path("../..", __dir__)
+    script = <<~RUBY
+      require "hive/version"
+      tag = Hive::VERSION
+      abort "mismatch" unless tag == Hive::VERSION
+      puts "ok"
+    RUBY
+    out, err, status = Open3.capture3("ruby", "-I#{root}/lib", "-e", script)
+    assert status.success?, err
+    assert_match(/ok/, out)
+  end
+end
diff --git a/test/unit/commands/doctor_test.rb b/test/unit/commands/doctor_test.rb
index e54f4fd5..4945f879 100644
--- a/test/unit/commands/doctor_test.rb
+++ b/test/unit/commands/doctor_test.rb
@@ -142,9 +142,11 @@ class HiveCommandsDoctorTest < Minitest::Test
 
       env = JSON.parse(out.string)
       assert_equal "hive-doctor.v1", env["schema"]
-      assert_equal 2, env["checks"].length
+      stage_checks = env["checks"].select { |c| c["kind"] == "stage" }
+      assert_equal 2, stage_checks.length
+      assert env["checks"].any? { |c| c["kind"] == "runtime_dep" },
+             "runtime dependency rows must be present"
       assert_equal 1, env["summary"]["missing"]
-      assert_equal 1, env["summary"]["present"]
       assert(env["checks"].any? { |c| c["stage"] == "plan" && c["status"] == "present" })
       assert(env["checks"].any? { |c| c["stage"] == "brainstorm" && c["status"] == "missing" })
     end
@@ -286,10 +288,11 @@ class HiveCommandsDoctorTest < Minitest::Test
         Hive::Commands::Doctor.new(config: cfg, project_root: nil, json: true, output: out).call
 
         env = JSON.parse(out.string)
-        warning = env.fetch("checks").find { |check| check["status"] == "warning" }
-        assert_equal 1, env.fetch("summary").fetch("warning")
-        assert_equal "billing-auth", warning.fetch("configured_skill")
-        assert_equal "ANTHROPIC_API_KEY", warning.fetch("skill")
+        billing = env.fetch("checks").find { |check| check["configured_skill"] == "billing-auth" }
+        assert billing, "expected billing-auth warning row"
+        assert_equal "warning", billing.fetch("status")
+        assert_operator env.fetch("summary").fetch("warning"), :>=, 1
+        assert_equal "ANTHROPIC_API_KEY", billing.fetch("skill")
       end
     end
   ensure
@@ -497,7 +500,7 @@ class HiveCommandsDoctorTest < Minitest::Test
 
       env = JSON.parse(out.string)
       assert_equal "hive-doctor.v1", env["schema"]
-      assert_equal 3, env["checks"].length
+      assert env["checks"].any? { |c| c["kind"] == "runtime_dep" }
 
       stage_entries = env["checks"].select { |c| c["kind"] == "stage" }
       reviewer_entries = env["checks"].select { |c| c["kind"] == "reviewer" }
diff --git a/test/unit/commands/uninstall_test.rb b/test/unit/commands/uninstall_test.rb
new file mode 100644
index 00000000..83af53ac
--- /dev/null
+++ b/test/unit/commands/uninstall_test.rb
@@ -0,0 +1,93 @@
+# frozen_string_literal: true
+
+require "test_helper"
+require "stringio"
+require "fileutils"
+require "hive/commands/uninstall"
+require "hive/service"
+
+class CommandsUninstallTest < Minitest::Test
+  include HiveTestHelper
+
+  class FakeService
+    attr_reader :stopped, :unregistered
+
+    def initialize(registered: true)
+      @registered = registered
+      @stopped = false
+      @unregistered = false
+    end
+
+    def registered? = @registered
+    def stop! = (@stopped = true)
+    def unregister! = (@unregistered = true; @registered = false)
+  end
+
+  def test_bash_uninstall_removes_binary_and_keeps_state_on_purge
+    with_tmp_dir do |dir|
+      old_home = ENV["HOME"]
+      old_hive = ENV["HIVE_HOME"]
+      ENV["HOME"] = dir
+      ENV["HIVE_HOME"] = File.join(dir, "xdg-unified")
+      FileUtils.mkdir_p(ENV["HIVE_HOME"])
+
+      bin = File.join(dir, ".local", "bin")
+      FileUtils.mkdir_p(bin)
+      File.write(File.join(bin, "hive"), "#!/bin/sh\necho 0.1.0\n")
+      File.chmod(0o755, File.join(bin, "hive"))
+      File.write(File.join(bin, "hv"), "link")
+
+      share = Hive::Paths.data_dir
+      FileUtils.mkdir_p(File.join(share, "templates"))
+      File.write(File.join(share, "install-channel.yml"), "channel: bash\n")
+
+      cfg = Hive::Paths.global_config_path
+      FileUtils.mkdir_p(File.dirname(cfg))
+      File.write(cfg, "registered_projects: []\n")
+
+      state = Hive::Paths.state_dir
+      FileUtils.mkdir_p(File.join(state, "daemon"))
+      File.write(File.join(state, "daemon", "daemon.out.log"), "log")
+
+      project_state = File.join(dir, "project", ".hive-state")
+      FileUtils.mkdir_p(project_state)
+      File.write(File.join(project_state, "keep-me"), "work")
+
+      out = StringIO.new
+      svc = FakeService.new
+      code = Hive::Commands::Uninstall.new(
+        purge: true,
+        input: StringIO.new,
+        output: out,
+        channel: :bash,
+        service: svc
+      ).call
+
+      assert_equal 0, code
+      assert svc.stopped
+      assert svc.unregistered
+      refute File.exist?(File.join(bin, "hive"))
+      refute File.exist?(cfg), "purge removes config"
+      assert File.exist?(File.join(state, "daemon", "daemon.out.log")), "state preserved"
+      assert File.exist?(File.join(project_state, "keep-me")), "project work preserved"
+      assert_match(/Skills are managed/i, out.string)
+    ensure
+      old_home.nil? ? ENV.delete("HOME") : ENV["HOME"] = old_home
+      old_hive.nil? ? ENV.delete("HIVE_HOME") : ENV["HIVE_HOME"] = old_hive
+    end
+  end
+
+  def test_brew_channel_instructs_native_remove
+    out = StringIO.new
+    svc = FakeService.new(registered: false)
+    Hive::Commands::Uninstall.new(
+      purge: true,
+      input: StringIO.new,
+      output: out,
+      channel: :brew,
+      service: svc
+    ).call
+    assert_match(/brew uninstall/i, out.string)
+    assert_match(/will not delete package-manager-owned/i, out.string)
+  end
+end
diff --git a/test/unit/commands/update_test.rb b/test/unit/commands/update_test.rb
new file mode 100644
index 00000000..7707b704
--- /dev/null
+++ b/test/unit/commands/update_test.rb
@@ -0,0 +1,46 @@
+# frozen_string_literal: true
+
+require "test_helper"
+require "stringio"
+require "hive/commands/update"
+
+class CommandsUpdateTest < Minitest::Test
+  def test_brew_channel_prints_and_execs_native_command
+    out = StringIO.new
+    seen = nil
+    exit_code = Hive::Commands::Update.new(
+      channel: :brew,
+      exec: ->(cmd) { seen = cmd; 0 },
+      output: out,
+      dry_run: false
+    ).call
+    assert_equal 0, exit_code
+    assert_includes out.string, "channel=brew"
+    assert_includes seen, "brew upgrade"
+    refute_includes seen, "curl"
+  end
+
+  def test_dry_run_does_not_exec
+    out = StringIO.new
+    called = false
+    Hive::Commands::Update.new(
+      channel: :bash,
+      exec: ->(_) { called = true },
+      output: out,
+      dry_run: true
+    ).call
+    refute called
+    assert_includes out.string, "install.sh"
+  end
+
+  def test_unknown_channel_exits_nonzero
+    out = StringIO.new
+    code = Hive::Commands::Update.new(
+      channel: :unknown,
+      exec: ->(_) { flunk "should not exec" },
+      output: out
+    ).call
+    assert_equal 1, code
+    assert_match(/unknown install channel/i, out.string)
+  end
+end
diff --git a/test/unit/install_channel_test.rb b/test/unit/install_channel_test.rb
new file mode 100644
index 00000000..a385ba01
--- /dev/null
+++ b/test/unit/install_channel_test.rb
@@ -0,0 +1,75 @@
+# frozen_string_literal: true
+
+require "test_helper"
+require "hive/install_channel"
+
+class InstallChannelTest < Minitest::Test
+  include HiveTestHelper
+
+  def with_marker(channel:, version: "0.1.0")
+    with_tmp_dir do |dir|
+      old = ENV["HIVE_HOME"]
+      ENV["HIVE_HOME"] = dir
+      FileUtils.mkdir_p(dir)
+      Hive::InstallChannel.write_marker!(channel: channel, version: version, install_path: "/tmp/hive")
+      yield dir
+    ensure
+      old.nil? ? ENV.delete("HIVE_HOME") : ENV["HIVE_HOME"] = old
+    end
+  end
+
+  def test_marker_file_wins
+    with_marker(channel: "bash") do
+      assert_equal :bash, Hive::InstallChannel.detect(binary_path: "/usr/local/bin/something")
+    end
+  end
+
+  def test_brew_cellar_heuristic
+    with_tmp_dir do |dir|
+      old = ENV["HIVE_HOME"]
+      ENV["HIVE_HOME"] = dir # no marker
+      path = "/opt/homebrew/Cellar/hive/0.1.0/bin/hive"
+      assert_equal :brew, Hive::InstallChannel.detect(binary_path: path)
+    ensure
+      old.nil? ? ENV.delete("HIVE_HOME") : ENV["HIVE_HOME"] = old
+    end
+  end
+
+  def test_pacman_heuristic_injectable
+    with_tmp_dir do |dir|
+      old = ENV["HIVE_HOME"]
+      ENV["HIVE_HOME"] = dir
+      runner = lambda do |args|
+        assert_equal "pacman", args[0]
+        ["hive-bin owns /usr/bin/hive", "", Struct.new(:success?).new(true)]
+      end
+      # Skip if pacman not present on host — pacman_owns? short-circuits.
+      if system("command", "-v", "pacman", out: File::NULL, err: File::NULL)
+        assert_equal :aur, Hive::InstallChannel.detect(binary_path: "/usr/bin/hive", runner: runner)
+      else
+        # Without pacman, unknown/source depending on path.
+        channel = Hive::InstallChannel.detect(binary_path: "/usr/bin/hive", runner: runner)
+        assert_includes %i[aur unknown source bash], channel
+      end
+    ensure
+      old.nil? ? ENV.delete("HIVE_HOME") : ENV["HIVE_HOME"] = old
+    end
+  end
+
+  def test_update_command_per_channel
+    assert_includes Hive::InstallChannel.update_command(:brew), "brew upgrade"
+    assert_includes Hive::InstallChannel.update_command(:bash), "install.sh"
+    assert_includes Hive::InstallChannel.update_command(:source), "git pull"
+  end
+
+  def test_bash_path_heuristic
+    with_tmp_dir do |dir|
+      old = ENV["HIVE_HOME"]
+      ENV["HIVE_HOME"] = dir
+      path = File.expand_path("~/.local/bin/hive")
+      assert_equal :bash, Hive::InstallChannel.detect(binary_path: path)
+    ensure
+      old.nil? ? ENV.delete("HIVE_HOME") : ENV["HIVE_HOME"] = old
+    end
+  end
+end
diff --git a/test/unit/paths_test.rb b/test/unit/paths_test.rb
new file mode 100644
index 00000000..bd2c19e1
--- /dev/null
+++ b/test/unit/paths_test.rb
@@ -0,0 +1,99 @@
+# frozen_string_literal: true
+
+require "test_helper"
+require "hive/paths"
+
+class PathsTest < Minitest::Test
+  include HiveTestHelper
+
+  def with_env(vars)
+    prev = {}
+    vars.each do |k, v|
+      prev[k] = ENV[k]
+      if v.nil?
+        ENV.delete(k)
+      else
+        ENV[k] = v
+      end
+    end
+    yield
+  ensure
+    prev.each do |k, v|
+      v.nil? ? ENV.delete(k) : ENV[k] = v
+    end
+  end
+
+  def test_honors_xdg_config_home
+    with_tmp_dir do |dir|
+      with_env("HIVE_HOME" => nil, "XDG_CONFIG_HOME" => File.join(dir, "cfg")) do
+        assert_equal File.join(dir, "cfg", "hive"), Hive::Paths.config_dir
+      end
+    end
+  end
+
+  def test_honors_xdg_data_state_cache
+    with_tmp_dir do |dir|
+      with_env(
+        "HIVE_HOME" => nil,
+        "XDG_DATA_HOME" => File.join(dir, "data"),
+        "XDG_STATE_HOME" => File.join(dir, "state"),
+        "XDG_CACHE_HOME" => File.join(dir, "cache")
+      ) do
+        assert_equal File.join(dir, "data", "hive"), Hive::Paths.data_dir
+        assert_equal File.join(dir, "state", "hive"), Hive::Paths.state_dir
+        assert_equal File.join(dir, "cache", "hive"), Hive::Paths.cache_dir
+      end
+    end
+  end
+
+  def test_defaults_under_home_when_xdg_unset
+    with_tmp_dir do |dir|
+      with_env(
+        "HOME" => dir,
+        "HIVE_HOME" => nil,
+        "XDG_CONFIG_HOME" => nil,
+        "XDG_DATA_HOME" => nil,
+        "XDG_STATE_HOME" => nil,
+        "XDG_CACHE_HOME" => nil
+      ) do
+        assert_equal File.join(dir, ".config", "hive"), Hive::Paths.config_dir
+        assert_equal File.join(dir, ".local", "share", "hive"), Hive::Paths.data_dir
+        assert_equal File.join(dir, ".local", "state", "hive"), Hive::Paths.state_dir
+        assert_equal File.join(dir, ".cache", "hive"), Hive::Paths.cache_dir
+      end
+    end
+  end
+
+  def test_hive_home_override_unifies_paths
+    with_tmp_dir do |dir|
+      with_env("HIVE_HOME" => dir) do
+        assert_equal File.expand_path(dir), Hive::Paths.config_dir
+        assert_equal File.expand_path(dir), Hive::Paths.data_dir
+        assert_equal File.expand_path(dir), Hive::Paths.state_dir
+        assert_equal File.expand_path(dir), Hive::Paths.cache_dir
+        assert_equal File.join(dir, "config.yml"), Hive::Paths.global_config_path
+      end
+    end
+  end
+
+  def test_source_checkout_mode_resolves_repo_templates
+    root = Hive::Paths.repo_root
+    assert File.directory?(File.join(root, "templates"))
+    assert File.directory?(File.join(root, "lib", "hive"))
+    assert Hive::Paths.source_checkout?
+    assert File.exist?(Hive::Paths.template_path("project_config.yml.erb"))
+  end
+
+  def test_installed_mode_fixture_resolves_from_data_dir
+    with_tmp_dir do |dir|
+      FileUtils.mkdir_p(File.join(dir, "templates"))
+      FileUtils.mkdir_p(File.join(dir, "lib", "hive"))
+      File.write(File.join(dir, "templates", "idea.md.erb"), "hi")
+      with_env("HIVE_HOME" => dir) do
+        assert_equal File.join(dir, "templates", "idea.md.erb"),
+                     Hive::Paths.template_path("idea.md.erb")
+        assert_equal File.expand_path(dir), Hive::Paths.install_root
+      end
+    end
+  end
+end
diff --git a/test/unit/service_test.rb b/test/unit/service_test.rb
new file mode 100644
index 00000000..9a489bb2
--- /dev/null
+++ b/test/unit/service_test.rb
@@ -0,0 +1,116 @@
+# frozen_string_literal: true
+
+require "test_helper"
+require "hive/service"
+require "stringio"
+
+class ServiceTest < Minitest::Test
+  include HiveTestHelper
+
+  FakeStatus = Struct.new(:success?) do
+    def exitstatus
+      success? ? 0 : 1
+    end
+  end
+
+  def with_home
+    with_tmp_dir do |dir|
+      old = ENV["HOME"]
+      ENV["HOME"] = dir
+      old_hive = ENV["HIVE_HOME"]
+      ENV["HIVE_HOME"] = File.join(dir, "hive-home")
+      FileUtils.mkdir_p(ENV["HIVE_HOME"])
+      yield dir
+    ensure
+      old.nil? ? ENV.delete("HOME") : ENV["HOME"] = old
+      old_hive.nil? ? ENV.delete("HIVE_HOME") : ENV["HIVE_HOME"] = old_hive
+    end
+  end
+
+  def test_renders_linux_unit_with_binary_path
+    with_home do |home|
+      calls = []
+      runner = lambda do |args|
+        calls << args
+        ["", "", FakeStatus.new(true)]
+      end
+      svc = Hive::Service.new(
+        binary_path: "/opt/hive/bin/hive",
+        runner: runner,
+        platform: :linux,
+        home: home
+      )
+      body = svc.render_unit
+      assert_includes body, "/opt/hive/bin/hive daemon start"
+      assert_includes body, "[Service]"
+      assert_includes body, "Description=Hive daemon"
+    end
+  end
+
+  def test_renders_macos_plist_with_binary_path
+    with_home do |home|
+      svc = Hive::Service.new(
+        binary_path: "/opt/homebrew/bin/hive",
+        runner: ->(_) { ["", "", FakeStatus.new(true)] },
+        platform: :macos,
+        home: home
+      )
+      body = svc.render_unit
+      assert_includes body, "/opt/homebrew/bin/hive"
+      assert_includes body, "com.ivankuznetsov.hive-daemon"
+      assert_includes body, "<key>RunAtLoad</key>"
+      assert_includes body, "<false/>"
+    end
+  end
+
+  def test_register_writes_unit_file
+    with_home do |home|
+      svc = Hive::Service.new(
+        binary_path: "/usr/bin/hive",
+        runner: ->(_) { ["", "", FakeStatus.new(true)] },
+        platform: :linux,
+        home: home
+      )
+      svc.register!
+      assert File.exist?(svc.unit_path)
+      assert_includes File.read(svc.unit_path), "/usr/bin/hive"
+      assert svc.registered?
+    end
+  end
+
+  def test_start_issues_enable_and_start
+    with_home do |home|
+      calls = []
+      runner = lambda do |args|
+        calls << args
+        ["active", "", FakeStatus.new(true)]
+      end
+      svc = Hive::Service.new(
+        binary_path: "/usr/bin/hive",
+        runner: runner,
+        platform: :linux,
+        home: home
+      )
+      svc.start!
+      flat = calls.map { |a| a.join(" ") }
+      assert flat.any? { |c| c.include?("systemctl --user enable") }
+      assert flat.any? { |c| c.include?("systemctl --user start") }
+    end
+  end
+
+  def test_unavailable_linux_without_systemctl
+    with_home do |home|
+      svc = Hive::Service.new(
+        binary_path: "/usr/bin/hive",
+        runner: ->(_) { ["", "Failed to connect", FakeStatus.new(false)] },
+        platform: :linux,
+        home: home
+      )
+      # Force command_exists? path: we can't easily stub Kernel.system for
+      # command -v; availability still exposes a reason string when platform is linux.
+      reason = svc.unavailable_reason
+      # On this CI host systemctl may or may not exist; reason is nil when available.
+      assert reason.nil? || reason.is_a?(String)
+    end
+  end
+end
